"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.transformProps = exports.withConditionalProvider = exports.ConditionalProvider = exports.TEXT_DECORATION = exports.FONT_WEIGHT = exports.TEXT_TRANSFORM = exports.MODES = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/esm/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/esm/objectWithoutPropertiesLoose"));

var _jsxRuntime = require("react/jsx-runtime");

var _react = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Mode = _interopRequireDefault(require("../context/Mode"));

/* eslint react/prop-types: 0 */
var MODES = {
  LIGHT: 'light',
  DARK: 'dark'
};
exports.MODES = MODES;
var TEXT_TRANSFORM = {
  CAPITALIZE: 'capitalize',
  UPPERCASE: 'uppercase',
  LOWERCASE: 'lowercase'
};
exports.TEXT_TRANSFORM = TEXT_TRANSFORM;
var FONT_WEIGHT = {
  THIN: 'thin',
  LIGHTER: 'lighter',
  LIGHT: 'light',
  REGULAR: 'regular',
  MEDIUM: 'medium',
  SEMIBOLD: 'semi-bold',
  BOLD: 'bold',
  BLACK: 'black'
};
exports.FONT_WEIGHT = FONT_WEIGHT;
var TEXT_DECORATION = {
  UNDERSCORE: 'underscore',
  OVERSCORE: 'overscore',
  UNDERLINE: 'underline',
  OVERLINE: 'overline',
  LINETHROUGH: 'line-through'
};
exports.TEXT_DECORATION = TEXT_DECORATION;

var ConditionalProvider = function ConditionalProvider(_ref) {
  var children = _ref.children,
      content = _ref.content,
      elementType = _ref.elementType,
      needsProvider = _ref.needsProvider,
      mode = _ref.mode,
      otherProps = (0, _objectWithoutPropertiesLoose2["default"])(_ref, ["children", "content", "elementType", "needsProvider", "mode"]);
  var contextProps = (0, _react.useContext)(_Mode["default"]) || {};

  if (!needsProvider) {
    return children((0, _extends2["default"])({}, otherProps, contextProps, {
      elementType: elementType,
      children: content
    }));
  }

  return /*#__PURE__*/(0, _jsxRuntime.jsx)(_Mode["default"].Provider, {
    value: {
      mode: mode
    },
    children: children((0, _extends2["default"])({}, otherProps, {
      mode: mode,
      elementType: elementType,
      children: content
    }))
  });
};

exports.ConditionalProvider = ConditionalProvider;

var withConditionalProvider = function withConditionalProvider(Component) {
  var Base = function Base(_temp) {
    var _ref2 = _temp === void 0 ? {} : _temp,
        otherProps = (0, _extends2["default"])({}, _ref2);

    var needsProvider = Object.keys(otherProps).includes('mode') && Object.entries(MODES).flat().includes(otherProps.mode);
    return /*#__PURE__*/(0, _jsxRuntime.jsx)(ConditionalProvider, (0, _extends2["default"])({}, otherProps, {
      content: otherProps.children,
      needsProvider: needsProvider,
      children: Component
    }));
  };

  return Base;
};

exports.withConditionalProvider = withConditionalProvider;

var transformProps = function transformProps(_temp2, displayName) {
  var _cx;

  var _ref3 = _temp2 === void 0 ? {} : _temp2,
      deprecated = _ref3.deprecated,
      elementType = _ref3.elementType,
      children = _ref3.children,
      fontWeight = _ref3.fontWeight,
      fullScreen = _ref3.fullScreen,
      fullWidth = _ref3.fullWidth,
      mode = _ref3.mode,
      textDecoration = _ref3.textDecoration,
      textTransform = _ref3.textTransform,
      className = _ref3.className,
      props = (0, _objectWithoutPropertiesLoose2["default"])(_ref3, ["deprecated", "elementType", "children", "fontWeight", "fullScreen", "fullWidth", "mode", "textDecoration", "textTransform", "className"]);

  var prefix = displayName ? "-" + displayName : '';
  return (0, _extends2["default"])({}, props, {
    className: (0, _classnames["default"])("sui-studio-doc" + prefix, (_cx = {}, _cx["sui-studio-doc" + prefix + "-tt-" + textTransform] = Object.entries(TEXT_TRANSFORM).flat().includes(textTransform), _cx["sui-studio-doc" + prefix + "-fw-" + fontWeight] = Object.entries(FONT_WEIGHT).flat().includes(fontWeight), _cx["sui-studio-doc" + prefix + "-td-" + textDecoration] = Object.entries(TEXT_DECORATION).flat().includes(textDecoration), _cx["sui-studio-doc" + prefix + "-deprecated"] = deprecated, _cx["sui-studio-doc" + prefix + "-full-screen"] = fullScreen, _cx["sui-studio-doc" + prefix + "-full-width"] = fullWidth, _cx["sui-studio-doc" + prefix + "-mode-" + mode] = Object.entries(MODES).flat().includes(mode), _cx), className)
  });
};

exports.transformProps = transformProps;

var BaseCore = function BaseCore(_ref4) {
  var children = _ref4.children,
      elementType = _ref4.elementType,
      otherProps = (0, _objectWithoutPropertiesLoose2["default"])(_ref4, ["children", "elementType"]);
  var ownProps = Object.assign({}, transformProps(otherProps));
  var ownElementType = elementType;

  if ((elementType === null || elementType === undefined || elementType === _react.Fragment) && ownProps.className === transformProps().className) {
    delete ownProps.className;
    return /*#__PURE__*/(0, _jsxRuntime.jsx)(_react.Fragment, (0, _extends2["default"])({}, ownProps, {
      children: "children"
    }));
  } else if (ownProps.className !== transformProps().className && (elementType === undefined || elementType === null || elementType === _react.Fragment)) {
    ownElementType = 'span';
  }

  return /*#__PURE__*/(0, _react.createElement)(ownElementType, (0, _extends2["default"])({}, ownProps), children);
};

var BaseConditionalProvided = withConditionalProvider(BaseCore);
BaseConditionalProvided.displayName = 'Base';
BaseConditionalProvided.propTypes = {};
BaseConditionalProvided.defaultProps = {};
var _default = BaseConditionalProvided;
exports["default"] = _default;