"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ListItem = exports.OrderedList = exports.UnorderedList = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/esm/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/esm/objectWithoutPropertiesLoose"));

var _jsxRuntime = require("react/jsx-runtime");

var _react = _interopRequireDefault(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Base = _interopRequireDefault(require("../Base.core"));

require("./List.scss");

/* eslint react/prop-types: 0 */

/**
 * The HTML `ol` element represents an ordered list of items — typically rendered as a numbered list.
 */
var UnorderedList = function UnorderedList(_ref) {
  var children = _ref.children,
      className = _ref.className,
      _ref$elementType = _ref.elementType,
      elementType = _ref$elementType === void 0 ? 'ul' : _ref$elementType,
      props = (0, _objectWithoutPropertiesLoose2["default"])(_ref, ["children", "className", "elementType"]);
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(_Base["default"], (0, _extends2["default"])({}, props, {
    elementType: elementType,
    className: (0, _classnames["default"])('sui-studio-doc-unordered-list', className),
    children: children
  }));
};

exports.UnorderedList = UnorderedList;
UnorderedList.displayName = 'UnorderedList';
/**
 * The HTML `ul` element represents an unordered list of items, typically rendered as a bulleted list.
 */

var OrderedList = function OrderedList(_ref2) {
  var children = _ref2.children,
      className = _ref2.className,
      _ref2$elementType = _ref2.elementType,
      elementType = _ref2$elementType === void 0 ? 'ol' : _ref2$elementType,
      props = (0, _objectWithoutPropertiesLoose2["default"])(_ref2, ["children", "className", "elementType"]);
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(_Base["default"], (0, _extends2["default"])({}, props, {
    elementType: elementType,
    className: (0, _classnames["default"])('sui-studio-doc-ordered-list', className),
    children: children
  }));
};

exports.OrderedList = OrderedList;
OrderedList.displayName = 'OrderedList';
/**
 * The HTML `li` element is used to represent an item in a list.
 */

var ListItem = function ListItem(_ref3) {
  var children = _ref3.children,
      className = _ref3.className,
      _ref3$elementType = _ref3.elementType,
      elementType = _ref3$elementType === void 0 ? 'li' : _ref3$elementType,
      props = (0, _objectWithoutPropertiesLoose2["default"])(_ref3, ["children", "className", "elementType"]);
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(_Base["default"], (0, _extends2["default"])({}, props, {
    elementType: elementType,
    className: (0, _classnames["default"])('sui-studio-doc-list-item', className),
    children: children
  }));
};

exports.ListItem = ListItem;
ListItem.displayName = 'ListItem';